program Segment_split
  !
  !Jesse's painting driver for sparse matricies

  use sep
  use paint_mod
  use random_mod
  use sorting_mod
  use lint2
  use warp_mod


  implicit none

  real, pointer, dimension(:,:)	                        :: d,norm_d,W_mat,D_mat,D_mat_exp,sparse_mat,sparse_mat2,Right_mat_sparse,Mult_1_sparse,Eig_sparse,xy,d_clip,norm_d_clip,weight_qc
!!$  real    (kind=8),dimension(:,:)                       ::Z_par_d,Eig_mat_d,AB_d,Q
  real     ,dimension(:,:)                               ::Eig_mat_s,Z_par_s,cut
  real,  dimension(:,:)	                                :: testa,testb,testc,Right_mat,Mult_1,norm_d_out,eig_vec_split_2d,horiz
  real,  dimension(:)	                                :: d_vec,d_vec_exp,outvec,outvec2,outvec3,dd,norm_d_1d,dd_1,dd_average,d_1d,dd_points,norm_d_clip_1d
!!$  real (kind=8), dimension(:)	                        :: W_par_d,Work_par_d
  real   , dimension(:)	                                :: W_par_s,Work_par_s,eig_vec_split,outcut
  integer,  dimension(:)	                        ::IWork_par,IFail_par,min_cut_loc(1),ISUPPZ(2)
  real							:: dx, dt,dy,y0,x0,t0,phiI,phiX,maxdat,mindat,rangedat,icol_rl,irow_rl,row1_rl,row2_rl,col1_rl,col2_rl,itval,d1,d2,d3,o1,o2,o3
!!$  real (kind=8)                                         :: VL_par_d,VU_par_d,Abstol_par_d
  real                                                  :: VL_par_s,VU_par_s,Abstol_par_s
  real							::dist,dist_exp,max_dist,exp_val,zero_tol
  real                                                  ::L,min_eig,max_eig,range_eig,stepsize_eig,cut_val,min_cut,d_ave,iz_rl,min_amp,max_amp
  integer                   :: method,sample_num,iz,iw,clip_percent_low,clip_percent_up  ! for select case
  integer							:: nt, nx, ny,nwx,nwt,icol,irow,row1,row2,col1,col2,IL_par,IU_par,M_par,LWork_par,Info_par,LIWork
  integer							:: it,ix,iy, max_steps,jx,kd,stat1,nodes
  integer :: counter_junk
  complex , dimension(:,:,:)                                :: cp,dip
  integer  :: col1a,row1a,col1b,row1b,col1c,row1c,col1d,row1d  ,  icola,irowa,icolb,irowb, indic,perturb_val
  integer  :: col2a,row2a,col2b,row2b,col2c,row2c,col2d,row2d   ,  icolc,irowc,icold,irowd
  integer  :: icola1,irowa1,icola2,irowa2
  integer  :: icolb1,irowb1,icolb2,irowb2
  integer  :: icolc1,irowc1,icolc2,irowc2
  integer  :: icold1,irowd1,icold2,irowd2,clip_count
  real :: weighta, weightb,weightc,weightd,new_clip_val,new_clip_val1,new_clip_val2
  real:: weighta1, weightb1,weightc1,weightd1
  real:: weighta2, weightb2,weightc2,weightd2
!!!for ARPACK
  integer  :: nev,ndv,ishfts,maxitr,mode,maxn,maxncv,lworkl,info,ido,ncv,n,ldv,nonzero,ierr,j,nconv,inonzero,d_vec_count,sparse_index,total_sparse,maxnev,five_percent,average_int,ave_cnt
  character :: bmat*1, which*2
  integer, dimension(:)::iparam(11),ipntr(11)
  real, dimension(:,:) ::v, d_ar,v_old
  real,dimension(:):: workl,workd,resid,ax,resid_ar,w_test,p_test !,test_vec_in,test_vec_out,w_test,p_test
  real :: tol,zero,sigma,snrm2,rand_num,rand_num_thresh,integration_val
  real,dimension(:)::rand_array,clip_list
  logical ::rvec,pnt_a_not_clip,pnt_b_not_clip
  logical,dimension(:)::select_lg
  integer :: col_1,row_1,col_2,row_2,step,drow,dcol,row1_back,col1_back,row2_back,col2_back

!!$
!!$ real,  dimension(:)	                                :: test_vec
!!$ real     ,dimension(:,:)                               :: test_mat


  !! hook up sep parameter input facility
  call sep_init(SOURCE)

  !! input parameters from history file
  call from_history("n1",nt); call from_history("n2",nx);
  call from_history("n3",ny);

!!$  call from_history ("d1",d1,1.) ; call from_history ("o1",o1,0.)
!!$  call from_history ("d2",d2,1.) ; call from_history ("o2",o2,0.)
!!$  call from_history ("d3",d3,1.) ; call from_history ("o3",o3,0.)


  ny=1;dt=1.;dx=1.;dy=1.;t0=0.;x0=0.;y0=0.

  call to_history( "n1", nx);  call to_history( "n2", nt);  call to_history( "n3", ny)
  call to_history( "d1", 1);  call to_history( "d2", 1);  call to_history( "d3", 1)
  call to_history( "o1", t0);  call to_history( "o2", x0);  call to_history( "o3", y0)
  call to_history("esize",4);



  !ny=1;dt=1.;dx=1.;dy=1.;t0=0.;x0=0.;y0=0.
!!$
!!$  call to_history( "n1", nx);  call to_history( "n2", nt);  call to_history( "n3", ny)
!!$  call to_history ("d1",1.)
!!$  call to_history ("d2",1.)
!!$  call to_history ("d3",1.) 
!!$  call to_history ("o1",0.)
!!$  call to_history ("o2",0.)
!!$  call to_history ("o3",0.)
!!$  call to_history("esize",4)

!!$  call to_history ("d1",d1)
!!$  call to_history ("d2",d2)
!!$  call to_history ("d3",d3) 
!!$  call to_history ("o1",o1)
!!$  call to_history ("o2",o2)
!!$  call to_history ("o3",o3)
!!$  call to_history("esize",4)


  !! allocate data and dip arrays
  allocate(d(nt,nx),d_1d(nt*nx),norm_d(nt,nx),norm_d_1d(nt*nx),d_vec(nt*nx),d_vec_exp(nt*nx),d_clip(nt,nx),norm_d_clip(nt,nx),norm_d_clip_1d(nt*nx),weight_qc(nt,nx))
  !  allocate(IFail_par(nt*nx))

  !  allocate(W_par_s(nt*nx),Z_par_s(nt*nx,nt*nx),IWork_par(3+nt*nx*5),IFail_par(nt*nx),
  allocate(outvec(nt*nx),outvec2(nt*nx),outvec3(nt*nx)) !Work_par_s(nt*nx*8)

  allocate(eig_vec_split(nx*nt),eig_vec_split_2d(nt,nx),horiz(nx,2),outcut(50),clip_list(nt*nx))
  !! read input data in and initialize dip arrays
  call sep_read(d)
!!$
!!$  call make_simple_model(d)
!!$  d=1.
!!$  d(1:,10:11)=.2
!!$  d(10:15,1:)=1.

  !!clip the input data
  clip_percent_low=nint((8.*real(nt*nx))/100.)!20!8!12 p1 !15 p2 !20    3 percent off of the bottom looked best
  clip_percent_up=nint(8.1*real(nt*nx)/100.)!20.1!8.1!18 !40 p1 !20 p2 ! 80  clipping the top not necessary
  d_1d=reshape(d,(/nt*nx/))
  call quick_sort(d_1d,nx*nt)
  min_amp=d_1d(clip_percent_low)
  max_amp=d_1d(clip_percent_up)
  deallocate(d_1d) 
  d_clip=min_amp
  d_clip=d
  clip_count=0
  clip_list=0.
  do it=1,nt
     do ix=1,nx
        if (d(it,ix)<=min_amp) then
           !     d_clip(it,ix)= exp(3.*d(it,ix))-1. !9******!3
           d(it,ix)=min_amp
           clip_count=clip_count+1
           new_clip_val=real(it)+.001*real(ix)
           clip_list(clip_count)=new_clip_val

           !  else
           !       d(it,ix)=min_amp


        else if (d(it,ix)>max_amp) then
           d(it,ix)=max_amp
           d_clip(it,ix)=min_amp
        else if  (d(it,ix)>min_amp) then
           d_clip(it,ix)=min_amp
        end if
     end do
  end do
  write(0,*) 'size of clip_list', clip_count

!!$!!!!!!!!!!!!!!!!!!!!delete
!!$  d=1.
!!$  d(5,5)=.5;d(6,5)=.7;d(4,5)=.7
!!$  clip_count=3
!!$  clip_list(1)=5.005
!!$  clip_list(2)=6.005
!!$  clip_list(3)=4.005
!!$  d_clip=d
!!$!!!!!!!!!!!!!!!!!!!!!!!!!


  max_dist=50!***40  !15 !15 !30 !  20.  ! was 7
  !best pars so far max_dist=20 average_nint=3, or max_dist=10 average_int=3
!!$$$$$$$$$$$$$$$$$$$$$  Normalize input image to 0-1 $$$$$$$$$$$$$$$$$$$$
  maxdat=maxval(d)
  mindat=minval(d)
  rangedat=maxdat-mindat
  norm_d=(d/rangedat-mindat/rangedat)
norm_d=norm_d*500.    
norm_d_1d=reshape(norm_d,(/nt*nx/))

  maxdat=maxval(d_clip)
  mindat=minval(d_clip)
  rangedat=maxdat-mindat
  norm_d_clip=(d_clip/rangedat-mindat/rangedat) 
norm_d_clip=norm_d_clip*1.
  norm_d_clip_1d=reshape(norm_d_clip,(/nt*nx/))
  write(0,*) 'min/max/avg(norm_d)',minval(norm_d),maxval(norm_d),sum(norm_d)/size(norm_d)
  write(0,*) 'min/max/avg(norm_d_clip)',minval(norm_d_clip),maxval(norm_d_clip),sum(norm_d_clip)/size(norm_d_clip)

  phiI=.1
  phiX=1.7 !4. !2.04 !10 !   4.
  !  max_dist=7.
  inonzero=1
  rand_num_thresh=-.5  !.5
  zero_tol=.0001 ! .0001
  average_int=1 !1 final best !2 !3
  perturb_val=0 !0 !0 final best !2
  allocate(sparse_mat(80000000,3),dd_average(nint(max_dist)+2),dd_points(nint(max_dist)+2))   !!!allocating 1 gig max

  !sparse_mat=0. 
  loop_over_columns:  do icol=1,nx*nt
     d_vec_count=0    !keep track of how many rows are in each column
     loop_over_rows:   do irow=1,nx*nt
!!$        icol_rl=icol
!!$        irow_rl=irow
!!$        row1=floor((icol_rl-1.)/nx)+1
!!$        col1=icol_rl-(row1-1)*nx;
!!$
!!$        row2=floor((irow_rl-1.)/nx)+1
!!$        col2=irow_rl-(row2-1)*nx

        !if (icol==17.and.irow==13) then
        call weight_to_data(nx,icol,irow,col1,row1,col2,row2)
        !write(0,*) 'row1',row1,'col1',col1,'row2',row2,'col2',col2
        !stop
        !end if
        row1_rl=row1
        col1_rl=col1
        row2_rl=row2
        col2_rl=col2

        !call weight_to_data(nx,icol,irow,col1,row1,col2,row2)



        dist=sqrt((row1_rl-row2_rl)**2+(col1_rl-col2_rl)**2)
        if (dist>max_dist) then !was 7 ! was 5.
           !    do nothing
        else

           if (icol==irow) then
              sparse_mat(inonzero,1)=irow
              sparse_mat(inonzero,2)=icol
              sparse_mat(inonzero,3)=1
              inonzero=inonzero+1
              d_vec_count=d_vec_count+1   ! a row has been added to this column
           else

              call random_number (rand_num)
              !             write(0,*) 'rand_num',rand_num
              if (rand_num>=rand_num_thresh) then
                 sample_num=dist    ! round down the distance(dist) to get the number of samples between points
                 ! write(0,*) 'sample_num',sample_num
                 if (dist-sample_num<=.5) sample_num=sample_num-1 !drop the last sample if it is too close to the end
                 !         write(0,*) 'dist',dist,'sample_num',sample_num     
                 nodes=sample_num+2
                 !!construct xy to be a 2D array containing pairs of coordinates for all steps between the two pixels
                 !!sample them from 
                 allocate(xy(sample_num,2),dd(sample_num),dd_1(nodes))
                 xy=0;dd=0;dd_1=0.
                 !assign xy pairs to each sample
                 do iz=1,sample_num
                    iz_rl=iz
                    xy(iz,1)=((row2_rl-row1_rl)/dist)*iz_rl+row1_rl
                    xy(iz,2)=((col2_rl-col1_rl)/dist)*iz_rl+col1_rl
                    !xy(iz,1)=((row2_rl-row1_rl)/(sample_num+1))*iz_rl+row1_rl
                    !xy(iz,2)=((col2_rl-col1_rl)/(sample_num+1))*iz_rl+col1_rl

                    !  write(0,*) 'xy',xy
                 end do
                 new_clip_val1=row1_rl+.001*col1_rl
                 new_clip_val2=row2_rl+.001*col2_rl

                 call lint2_init(nt,nx,1.,dt,1.,dx,xy)

                 pnt_a_not_clip= (IsNew(clip_list,clip_count,new_clip_val1)) !true if not clipped
                 pnt_b_not_clip= (IsNew(clip_list,clip_count,new_clip_val2))
                 !is new returns a true if the point has not been clipped



                 if ((pnt_a_not_clip).and.(pnt_b_not_clip)) then 

                    stat1=lint2_lop(.false.,.false.,norm_d_1d,dd_1(2:nodes-1)) 
                    dd_1(1)=norm_d(row1,col1)
                    dd_1(nodes)=norm_d(row2,col2)

                 else  
                    stat1=lint2_lop(.false.,.false.,norm_d_clip_1d,dd_1(2:nodes-1))
                    dd_1(1)=norm_d_clip(row1,col1)
                    dd_1(nodes)=norm_d_clip(row2,col2)
                 end if


                 !write(0,*) 'dd',dd
                 dist_exp=exp(-dist/(phiX**2))
                 !       d_ave=exp(-(norm_d(row1,col1)-norm_d(row2,col2))**2/(phiI**2))*dist_exp


                 !          d_ave=(sum(dd)+norm_d(row1,col1)+norm_d(row2,col2))/(sample_num+2)*dist_exp  !  weighted against distance            
                 !                      d_ave=(sum(dd)+norm_d(row1,col1)+norm_d(row2,col2))/(sample_num+2)
                 !integration_val=(sum(dd)+norm_d(row1,col1)+norm_d(row2,col2))
                 !   write(0,*) 'dist',dist  
                 if (average_int==1) then
                    if(nodes/=2) then! (nodes>6)then! (nodes/=2) then!  then ! (nodes>3)then! (nodes/=2) then
                       !      d_ave=(sum(dd_1)/size(dd_1)) !*dist_exp
                       !d_ave=minval(dd_1)
                       if ((pnt_a_not_clip).and.(pnt_b_not_clip)) then 
                          d_ave=minval(dd_1(2:nodes-1))
                       else
                          !d_ave=minval(dd_1(1:nodes))
                          !write(0,*) 'd_ave',d_ave,'dist',dist,'nodes',nodes
                          ! d_ave=(sum(dd_1))
                          ! d_ave=minval(dd_1) !(2:nodes-1))  !*dist_exp !use dd_1 
                          !write(0,*) 'weight',d_ave
                          !if one is clipped and one isn't clipped
                          if((.not.pnt_a_not_clip).and.(pnt_b_not_clip)) then !if a is clipped only   
                             if(dd_1(2)<dd_1(1)) then
                                d_ave=0.0
                             else ! if (dd_1(2)>=dd_1(1)) then
                                d_ave=1.
                             end if
                          end if

                          if((.not.pnt_b_not_clip).and.(pnt_a_not_clip)) then ! if b is clipped only
                             if(dd_1(nodes-1)<dd_1(nodes)) then
                                d_ave=0.0
                             else ! if (dd_1(nodes-1)>=dd_1(nodes)) then
                                d_ave=1.
                             end if
                          end if

                          if((.not.pnt_b_not_clip).and.(.not.pnt_a_not_clip)) then ! if both are clipped
                             if((dd_1(2)<dd_1(1)).and.(dd_1(nodes-1)<dd_1(nodes))) then
                                d_ave=0.0
                             else
                                d_ave=1.
                             end if
                          end if

                       end if
                    else
                       if ((pnt_a_not_clip).and.(pnt_b_not_clip)) then 
                          d_ave=1.
                       else

                          drow=row2-row1
                          dcol=col2-col1

                          row1_back=row1-drow
                          col1_back=col1-dcol

                          row2_back=row2+drow
                          col2_back=col2+dcol

                          if (row1_back>=1.and.row1_back<=nt.and.col1_back>=1.and.col1_back<=nx) then
                             if (norm_d_clip(row1_back,col1_back)>norm_d_clip(row1,col1).and.norm_d_clip(row2,col2)>norm_d_clip(row1,col1)) then
                                if (row1<=row2.and.col1<=col2) then ! break only along north-east
                                   d_ave=0.
                                else
                                   d_ave=1.
                                end if
                             end if
                          else
                             !  d_ave=1.                  
                          end if

                          if (row2_back>=1.and.row2_back<=nt.and.col2_back>=1.and.col2_back<=nx) then
                             if (norm_d_clip(row2_back,col2_back)>norm_d_clip(row2,col2).and.norm_d_clip(row1,col1)>norm_d_clip(row2,col2)) then
                                if (row2<=row1.and.col2<=col1) then ! break only along north-east
                                   d_ave=0.
                                else
                                   d_ave=1.
                                end if


                             end if
                          else
                             !    d_ave=1.
                          end if
                       end if
                       ! sample the other side of each pixel
                       !allocate(xy_a(2,2),dd_a(2),xy_b(2,2),dd_b(2))


                       !   d_ave=min(dd_1(1),dd_1(nodes))
                       !!                       d_ave=exp(-1*abs(dd_1(1)-dd_1(nodes)))
                       !   d_ave=1.-abs(dd_1(1)-dd_1(nodes))
                       !      d_ave=(dd_1(1)+dd_1(nodes))/2.

                       !d_ave=max(dd_1(1),dd_1(nodes))
                       !             d_ave=1.

!!$                       if (row1==row2.or.col1==col2) then
!!$d_ave=1.
!!$else
                       !d_ave=0.
!!$end if

                       !write(0,*) 'd_ave',d_ave
                    end if
                 else

!!$!test case
!!$!!!$nodes=7
!!$!!!$average_int=3
!!$!!!$dd_1(1)=1;dd_1(2)=2;dd_1(3)=2;dd_1(4)=4;dd_1(5)=5;dd_1(6)=6;dd_1(7)=7

!!!!!!!!!!!!!!! THIS IS FOR AVERAGING ALONG SEARCH

                    !      if (nodes/=2) then
                    if (nodes>=average_int+2) then
                       !dd_average(1)=dd(1)
                       ave_cnt=0
                       !      do iw=1,nodes-(average_int-1)
                       do iw=1,nodes-(average_int+1)
                          !    dd_average(iw+1)=sum(dd(1+(iw-1):average_int+(iw-1)))/average_int
                          ave_cnt=ave_cnt+1
                          dd_average(ave_cnt)=sum(dd_1(2+(ave_cnt-1):1+average_int+(ave_cnt-1)))/average_int
                       end do
                       !dd_points(2:ave_cnt+1)=dd_average(1:ave_cnt)
                       !dd_points(1)=dd_1(1)
                       !dd_points(ave_cnt+1)=dd_1(nodes)
                       d_ave=minval(dd_average(1:ave_cnt))
                    elseif (nodes>2)then  
                       d_ave=sum(dd_1(2:nodes-1))/size(dd_1(2:nodes-1))
                    else
                       d_ave=exp(-1*abs(dd_1(1)-dd_1(nodes)))
                       d_ave=1.-abs(dd_1(1)-dd_1(nodes))
                       !   d_ave=1.
                       !     d_ave=.1
                    end if

                 end if


!!$write(0,*) 'dd_points',dd_points
!!$write(0,*) 'd_ave',d_ave
!!$stop
                 !d_ave=minval(dd_average(1:iw+2))
                 !         d_ave=minval(dd_average(1:iw+1)) !*dist_exp ! this is the mininum weight for the path between 2 points
                 !write(0,*) 'dd_1',dd_1
                 !d_ave=minval(dd_1)
                 !write(0,*) 'sample_num',sample_num
                 !write(0,*) 'iw+1',iw+1
                 !stop
!!$
!!$if (sample_num>=5)then
!!$write(0,*) 'dd_average',dd_average
!!$write(0,*) 'dd',dd
!!$write(0,*) 'sample_num',sample_num
!!$write(0,*) 'size of dd', size(dd)
!!$write(0,*) 'iw',iw
!!$stop
!!$end if
                 deallocate(xy,dd,dd_1)
                 if (d_ave>zero_tol)then
                    sparse_mat(inonzero,1)=irow
                    sparse_mat(inonzero,2)=icol
                    sparse_mat(inonzero,3)=d_ave
                    inonzero=inonzero+1
                    d_vec_count=d_vec_count+1  ! a row 
                 end if


              end if
           end if


        end if

     end do loop_over_rows
     !!construct d_vec   finished with the current column, now sum all rows in current column
     d_vec(icol)=sum(sparse_mat(inonzero-d_vec_count:inonzero-1,3))
     d_vec_exp(icol)=d_vec(icol)**-.5
     write(0,*) 'finished column',icol
  end do loop_over_columns






  !write(0,*) 'sparemat',sparse_mat
!!$write(0,*) 'd_vec',d_vec
!!$write(0,*) 'd_vec_exp',d_vec_exp

  total_sparse=inonzero-1  ! total number of records in sparse matrix

  allocate(sparse_mat2(total_sparse,3))
  sparse_mat2=sparse_mat(1:total_sparse,1:3)
  deallocate(sparse_mat)
  allocate(sparse_mat(total_sparse,3))
  sparse_mat=sparse_mat2
  deallocate(sparse_mat2)

  ! rite out qc matrix
  weight_qc=0.
  step=1*nx !how far away to sample
  do it=1,total_sparse
     if ((sparse_mat(it,1)+step)==sparse_mat(it,2)) then
        call weight_to_data(nx,nint(sparse_mat(it,1)+step),nint(sparse_mat(it,1)+step),col_1,row_1,col_2,row_2)
        weight_qc(row_1,col_1)=sparse_mat(it,3)
     end if
  end do

!write(0,*) maxval(sparse_mat(:,3))
!stop
!!! PERTURB each weight
  if (perturb_val/=0) then
     write(0,*) 'perturbing the weight'
     loop_over_sparse:  do sparse_index=1,total_sparse
        irow=nint(sparse_mat(sparse_index,1))
        icol=nint(sparse_mat(sparse_index,2))

        call weight_to_data(nx,icol,irow,col1,row1,col2,row2)  !output the pair of nodes that each weight coresponds to
        col1a=col1-perturb_val
        row1a=row1

        col1b=col1+perturb_val
        row1b=row1

        col1c=col1
        row1c=row1-perturb_val

        col1d=col1
        row1d=row1+perturb_val

        col2a=col2-perturb_val
        row2a=row2

        col2b=col2+perturb_val
        row2b=row2

        col2c=col2
        row2c=row2-perturb_val

        col2d=col2
        row2d=row2+perturb_val

        call data_to_weight(nx,icola,irowa,col1a,row1a,col2a,row2a) !the weight between each shifted node
        call data_to_weight(nx,icola1,irowa1,col1,row1,col1a,row1a) !the weight from the original node 1 to the shifted node
        call data_to_weight(nx,icola2,irowa2,col2,row2,col2a,row2a) !the weight from the original node 2 to the shifted node

        call data_to_weight(nx,icolb,irowb,col1b,row1b,col2b,row2b) !the weight between each shifted node
        call data_to_weight(nx,icolb1,irowb1,col1,row1,col1b,row1b) !the weight from the original node 1 to the shifted node
        call data_to_weight(nx,icolb2,irowb2,col2,row2,col2b,row2b) !the weight from the original node 2 to the shifted node

        call data_to_weight(nx,icolc,irowc,col1c,row1c,col2c,row2c)
        call data_to_weight(nx,icolc1,irowc1,col1,row1,col1c,row1c) !the weight from the original node 1 to the shifted node
        call data_to_weight(nx,icolc2,irowc2,col2,row2,col2c,row2c) !the weight from the original node 2 to the shifted node

        call data_to_weight(nx,icold,irowd,col1d,row1d,col2d,row2d)
        call data_to_weight(nx,icold1,irowd1,col1,row1,col1d,row1d) !the weight from the original node 1 to the shifted node
        call data_to_weight(nx,icold2,irowd2,col2,row2,col2d,row2d) !the weight from the original node 2 to the shifted node


!!!need to look up each one from the sparse matrix and take the maximum weight value
        weighta=0. ; weightb=0. ; weightc=0. ; weightd=0. 
        indic=0
        loop_over_sparse_again: do it=1,total_sparse !max(1,sparse_index-(nx*(nx*nint(max_dist)*2+1))),total_sparse !min(total_sparse,sparse_index+(nx*(nx*nint(max_dist)*2+1)))
           if (nint(sparse_mat(it,1))== irowa.and.nint(sparse_mat(it,2))==icola ) weighta =sparse_mat(it,3);indic=indic+1
           if (nint(sparse_mat(it,1))==irowa1.and.nint(sparse_mat(it,2))==icola1) weighta1=sparse_mat(it,3);indic=indic+1
           if (nint(sparse_mat(it,1))==irowa2.and.nint(sparse_mat(it,2))==icola2) weighta2=sparse_mat(it,3);indic=indic+1

           if (nint(sparse_mat(it,1))== irowb.and.nint(sparse_mat(it,2))==icolb ) weightb =sparse_mat(it,3);indic=indic+1
           if (nint(sparse_mat(it,1))==irowb1.and.nint(sparse_mat(it,2))==icolb1) weightb1=sparse_mat(it,3);indic=indic+1
           if (nint(sparse_mat(it,1))==irowb2.and.nint(sparse_mat(it,2))==icolb2) weightb2=sparse_mat(it,3);indic=indic+1

           if (nint(sparse_mat(it,1))== irowc.and.nint(sparse_mat(it,2))==icolc ) weightc =sparse_mat(it,3);indic=indic+1
           if (nint(sparse_mat(it,1))==irowc1.and.nint(sparse_mat(it,2))==icolc1) weightc1=sparse_mat(it,3);indic=indic+1
           if (nint(sparse_mat(it,1))==irowc2.and.nint(sparse_mat(it,2))==icolc2) weightc2=sparse_mat(it,3);indic=indic+1

           if (nint(sparse_mat(it,1))== irowd.and.nint(sparse_mat(it,2))==icold ) weightd =sparse_mat(it,3);indic=indic+1
           if (nint(sparse_mat(it,1))==irowd1.and.nint(sparse_mat(it,2))==icold1) weightd1=sparse_mat(it,3);indic=indic+1
           if (nint(sparse_mat(it,1))==irowd2.and.nint(sparse_mat(it,2))==icold2) weightd2=sparse_mat(it,3);indic=indic+1

           if (indic>=12) EXIT  !stop search if it finds all 9 weights
        end do loop_over_sparse_again
        sparse_mat(sparse_index,3)=max(sparse_mat(sparse_index,3),min(weighta,weighta1,weighta2),min(weightb,weightb1,weightb2),min(weightc,weightc1,weightc2), min(weightd,weightd1,weightd2) )
        !   sparse_mat(sparse_index,3)=max(sparse_mat(sparse_index,3),(weighta+weighta1+weighta2)/3,(weightb+weightb1+weightb2)/3,(weightc+weightc1+weightc2)/3, (weightd+weightd1+weightd2)/3 )
     end do loop_over_sparse
     write(0,*) 'perturbed the weight'
  end if
!!$do it=1, total_sparse
!!$write(0,*) 'sparse_mat',sparse_mat(it,1),sparse_mat(it,2),sparse_mat(it,3)
!!$end do
!!$!stop
!!$
!!$do it=1,total_sparse
!!$write(0,*) 'sparse_mat',sparse_mat(it,1:)
!!$end do
  write(0,*) 'total_sparse', total_sparse
  write(0,*) 'after W construction'
!!$
!!$  stop
!!$  do ix=1,nx*nt
!!$     d_vec(ix)=sum(W_mat(1:nx*nt,ix))
!!$     d_vec_exp(ix)=d_vec(ix)**-.5
!!$  end do


!!!make a sparse version of D_mat-W_mat
  allocate(Right_mat_sparse(total_sparse,3))
  Right_mat_sparse(1:,1:2)=sparse_mat(1:,1:2)
  Right_mat_sparse(1:,3)=-1*sparse_mat(1:,3)
  do sparse_index=1,total_sparse
     if (sparse_mat(sparse_index,1)==sparse_mat(sparse_index,2))then
        Right_mat_sparse(sparse_index,1:2)=sparse_mat(sparse_index,1:2)
        Right_mat_sparse(sparse_index,3)=d_vec(nint(sparse_mat(sparse_index,2)))-sparse_mat(sparse_index,3)
     end if
  end do
  write(0,*) 'did D-W, about to do right multiply'
!!$
!!$do ix=1,total_sparse
!!$write(0,*) 'Right_mat_sparse',Right_mat_sparse(ix,1:)
!!$end do



!!!make a sparse matrix version of Right_mat_sparse * d_vec_exp when d_vec_exp is a diagonal matrix
  allocate(Mult_1_sparse(total_sparse,3))
  do sparse_index=1,total_sparse
     Mult_1_sparse(sparse_index,1:2)=Right_mat_sparse(sparse_index,1:2)
     Mult_1_sparse(sparse_index,3)=Right_mat_sparse(sparse_index,3)*d_vec_exp(nint(Mult_1_sparse(sparse_index,2)))
  end do
  deallocate(Right_mat_sparse) 
!!$
!!$do ix=1,total_sparse
!!$write(0,*) 'Mult_1_sparse',Mult_1_sparse(ix,1:)
!!$end do



  write(0,*) 'did right multiply, about to do left multiply'
!!!make a sparse matrix version of d_vec_exp * Mult_1_sparse where d_vec_exp is a diagonal matrix
  allocate(Eig_sparse(total_sparse,3))
  do sparse_index=1,total_sparse
     Eig_sparse(sparse_index,1:2)=Mult_1_sparse(sparse_index,1:2)
     Eig_sparse(sparse_index,3)=Mult_1_sparse(sparse_index,3)*d_vec_exp(nint(Mult_1_sparse(sparse_index,1)))
  end do
  deallocate(Mult_1_sparse)
!!$
!!$!!!!!!!!!!!!!!!adding a little to the diagonal
!!$  do sparse_index=1,total_sparse
!!$     if (Eig_sparse(sparse_index,1)==Eig_sparse(sparse_index,2)) then
!!$        Eig_sparse(sparse_index,3)=Eig_sparse(sparse_index,3)+.001
!!$     end if
!!$  end do



  ! maxn=(nx*nt)**2
  maxn=nx*nt
  !maxn=256
  ! maxn=4
  !maxncv= 4

  maxncv=100 !25  !!!! 100 9/21/03
  maxnev=10 !10
  !maxnev=4

  allocate(v(maxn,maxncv),v_old(maxn,maxncv),workl(maxncv*(maxncv*8)),workd(3*maxn))
  allocate(d_ar(maxncv,2),resid_ar(maxn),ax(maxn))
  d_ar=0.
!!$
!!$allocate(test_vec_in(4),test_vec_out(4))
!!$test_vec_in(1)=1
!!$test_vec_in(2)=2
!!$test_vec_in(3)=3
!!$test_vec_in(4)=4 
!!$call sparse_mat_mult(Eig_sparse,test_vec_in,test_vec_out,nt,nx)
!!$write(0,*) 'test',test_vec_out
!!$stop
  ! call make_sparse(Eig_mat_s,sparse_mat)
  ! nx = 10
  !nx=4
  write(0,*) 'nx',nx
  write(0,*) 'nt',nt
  n=nx*nt
  !n=(nx*nt)**2
  write(0,*) 'n',n
  !  n = maxn
  nev =2! 4 !2
  !nev=4 old way 
  ncv =20! 10 !20   !!!!! 100 9/21/03
  !ncv=6




  if ( n .gt. maxn ) then
     write(0,*)  ' ERROR with _SDRV1: N is greater than MAXN '
     go to 9000
  else if ( nev .gt. maxnev ) then
     write(0,*)  ' ERROR with _SDRV1: NEV is greater than MAXNEV '
     go to 9000
  else if ( ncv .gt. maxncv ) then
     write(0,*)  ' ERROR with _SDRV1: NCV is greater than MAXNCV '
     go to 9000
  end if






  write(0,*) 'starting eigenvalue computations'

  ldv=maxn
  bmat = 'I'
  which = 'SM'

  lworkl = ncv*(ncv+8)
  tol = zero 
  !tol=.0001
  ! if (exist_file("init_eig")) then
  write(0,*) 'min/max resid',maxval(resid_ar),minval(resid_ar)
  call sreed('frst.H',resid_ar,4*nt*nx)
  allocate(rand_array(nt*nx))
  call random_number(rand_array)
  write(0,*) 'without random numbers'
  write(0,*) 'min/max/avr resid',maxval(resid_ar),minval(resid_ar),sum(resid_ar)/size(resid_ar)
  ! resid_ar=resid_ar !+.0001*rand_array
  deallocate(rand_array) 
  info=1
  !ido=0
  write(0,*) 'using initial eigenguess'
  write(0,*) 'min/max resid',maxval(resid_ar),minval(resid_ar)
  !stop
  !  else
  info=0   ! initialize with random numbers
  ido = 0
  !  end if

  write(0,*) 'info',info
  !stop


  ishfts = 1
  maxitr = 300
  mode   = 1

  iparam(1) = ishfts 
  iparam(3) = maxitr 
  iparam(7) = mode 
  !  resid_ar=0
  it=1
  write(0,*) 'n',n

  write(0,*) 'ido ', ido
  write(0,*)  'bmat ', bmat
  write(0,*)  'n ', n
  write(0,*) 'which ', which
  write(0,*) 'nev ', nev
  write(0,*) 'tol ', tol
  !       write(0,*)  'resid_ar ', resid_ar
  write(0,*)  'ncv ', ncv
  !        write(0,*)  'v ', v
  write(0,*)  'ldv ', ldv   
  write(0,*)  'iparam ', iparam
!!$  !  write(0,*)  'ipntr ', ipntr
  !       write(0,*) 'workd ', workd
  !      write(0,*)  'workl ', workl
  write(0,*)  'lworkl ', lworkl
  write(0,*)  'info ', info


!!$
  do counter_junk=1,1
     it=1
     if (counter_junk==2) then
        resid_ar=v_old(1:nt*nx,1) !v(1:nt*nx,1)+v(1:nt*nx,2)!+v(1:nt*nx,3)+v(1:nt*nx,4)
!!$! call sreed('frst.H',resid_ar,4*nt*nx)
!!$write(0,*) 'min/max resid',maxval(resid_ar),minval(resid_ar)
        info=1
!!$!ido=0
        workl=0. ;workd=0.;d_ar=0.
        v=0.
!!$!v(1:nt*nx,1)=resid_ar
        iparam=0 ; ipntr=0
        maxn=nx*nt
        !maxn=256
        ! maxn=4
        !maxncv= 4
        ido=0
        maxncv=100 !25  !!!! 100 9/21/03
        maxnev=10 !10
        ishfts = 1
        maxitr = 300
        mode   = 1
        n=nx*nt
        !n=(nx*nt)**2
        write(0,*) 'n',n
        !  n = maxn
        nev =1!2! 4 !2
        !nev=4 old way 
        ncv =20!10 !10 !20 ! 100 !20   !!!!! 100 9/21/03
        !ncv=6


        ldv=maxn
        bmat = 'I'
        which = 'SM'

!!$ ! lworkl = ncv*(ncv+8)
        tol = zero 


        iparam(1) = ishfts 
        iparam(3) = maxitr 
        iparam(7) = mode 
!!$
!!$ it=1

        write(0,*) 'ido ', ido
        write(0,*)  'bmat ', bmat
        write(0,*)  'n ', n
        write(0,*) 'which ', which
        write(0,*) 'nev ', nev
        write(0,*) 'tol ', tol
        !       write(0,*)  'resid_ar ', resid_ar
        write(0,*)  'ncv ', ncv
        !        write(0,*)  'v ', v
        write(0,*)  'ldv ', ldv   
        write(0,*)  'iparam ', iparam
!!$  !  write(0,*)  'ipntr ', ipntr
        !       write(0,*) 'workd ', workd
        !      write(0,*)  'workl ', workl
        write(0,*)  'lworkl ', lworkl
        write(0,*)  'info ', info


!!$

        !stop
     end if
10   continue
!!$
!!$  write(0,*)  '!!!!!!!!!!!!   INPUT  !!!!!!!!!!!!!!!'
!!$  write(0,*) 'ido ', ido
!!$  write(0,*)  'bmat ', bmat
!!$  write(0,*)  'n ', n
!!$  write(0,*) 'which ', which
!!$  write(0,*) 'nev ', nev
!!$  write(0,*) 'tol ', tol
!!$  !       write(0,*)  'resid_ar ', resid_ar
!!$  write(0,*)  'ncv ', ncv
!!$  !        write(0,*)  'v ', v
!!$  write(0,*)  'ldv ', ldv   
!!$  write(0,*)  'iparam ', iparam
     !  write(0,*)  'ipntr ', ipntr
!!$  !       write(0,*) 'workd ', workd
!!$  !      write(0,*)  'workl ', workl
!!$  write(0,*)  'lworkl ', lworkl
!!$  write(0,*)  'info ', info
!!$stop
     !  write(0,*) 'here a'
     call ssaupd ( ido, bmat, n, which, nev, tol, resid_ar,ncv, v, ldv, iparam, ipntr, workd, workl,lworkl, info )
     ! write(0,*) 'here b'

     !write(0,*) 'ipntr(1)',ipntr
     !  write(0,*) 'workd',workd
     !  write(0,*) 'workd(ipntr(1))',workd
     !write(0,*) 'ipntr(1)',ipntr(1)
!!$
!!$
!!$  write(0,*)  '!!!!!!!!!!!!   OUTPUT  !!!!!!!!!!!!!!!'
!!$  write(0,*) 'ido ', ido
!!$  write(0,*)  'bmat ', bmat
!!$  write(0,*)  'n ', n
!!$  write(0,*) 'which ', which
!!$  write(0,*) 'nev ', nev
!!$  write(0,*) 'tol ', tol
!!$!         write(0,*)  'resid_ar ', resid_ar
!!$  write(0,*)  'ncv ', ncv
!!$!          write(0,*)  'v ', v
!!$  write(0,*)  'ldv ', ldv   
!!$  write(0,*)  'iparam ', iparam
     ! write(0,*)  'ipntr ', ipntr
!!$!         write(0,*) 'workd ', workd
!!$!        write(0,*)  'workl ', workl
!!$  write(0,*)  'lworkl ', lworkl
     write(0,*)  'info ', info


!!$if (counter_junk==2) then
!!$ ! stop
!!$end if
     !  write(0,*) 'ido',ido
     !  ido=-1
     if (ido .eq. -1 .or. ido .eq. 1) then


        !write(0,*) 'workd before',workd(ipntr(1):ipntr(1)+nx*nt-1)
        !write(0,*) 'nt*nx',nt*nx
        !write(0,*) 'workd(ipntr(1):ipntr(1)+nx*nt)',workd(ipntr(1):ipntr(1)+nx*nt)

        ! call av_test (nx, workd(ipntr(1)), workd(ipntr(2)))
        call sparse_mat_mult(Eig_sparse, workd(ipntr(1):ipntr(1)+nx*nt-1), workd(ipntr(2):ipntr(2)+nx*nt-1),nt,nx,ny)
        !if (it==2)then
        !    write(0,*) 'workd after',workd
        !    write(0,*) 'ipntr',ipntr
        !    write(0,*) 'nx',nx
        !stop
        !end if
        it=it+1
        !stop
        write(0,*) 'it',it
        !write(0,*) 'ipntr',ipntr(1),ipntr(2)
        !write(0,*) 'workd(1:16)',workd(1:16)
        !stop
        go to 10
     end if
     !write(0,*) 'it',it
     !write(0,*) 'info', info


!!$
     if ( info .lt. 0 ) then
        write(0,*)  ' '
        write(0,*)  ' Error with _saupd, info = ', info
        write(0,*) ' Check documentation in _saupd '
        write(0,*)  ' '
     else 
        write(0,*) 'rvec=true'
        rvec = .true.
        allocate(select_lg(maxncv))
!!$
        v_old=v
        call sseupd ( rvec, 'All', select_lg, d_ar, v, ldv, sigma,bmat, n, which, nev, tol, resid, ncv, v, ldv,iparam, ipntr, workd, workl, lworkl, ierr )
        if ( ierr .ne. 0) then
!!$
           write(0,*)  ' '
           write(0,*)  ' Error with _seupd, info = ', ierr
           write(0,*)  ' Check the documentation of _seupd. '
           write(0,*)  ' '

        else
!!$
           nconv =  iparam(5)
           write(0,*) 'nconv', nconv
           do 20 j=1, nconv


              !       call  av_test(nx, v(1,j), ax)
              call sparse_mat_mult(Eig_sparse,v(1:nt*nx,j),ax,nx,nt,ny)
              !          write(0,*) 'ax',ax


              call saxpy(n, -d_ar(j,1), v(1,j), 1, ax, 1)
              d_ar(j,2) = snrm2(n, ax, 1)
              d_ar(j,2) = d_ar(j,2) / abs(d_ar(j,1))

20            continue

              call smout(6, nconv, 2, d_ar, maxncv, -6, 'Ritz values and relative residuals')
              !write(0,*) 'd_ar', d_ar
              !write(0,*) 'resids'
           end if






           if ( info .eq. 1) then
              write(0,*) ' '
              write(0,*) ' Maximum number of iterations reached.'
              write(0,*) ' '
           else if ( info .eq. 3) then
              write(0,*) ' ' 
              write(0,*) ' No shifts could be applied during implicit',\
              ' Arnoldi update, try increasing NCV.'
              write(0,*) ' '
           end if

           write(0,*) ' '
           write(0,*) ' _SDRV1 '
           write(0,*) ' ====== '
           write(0,*) ' '
           write(0,*) ' Size of the matrix is ', n
           write(0,*) ' The number of Ritz values requested is ', nev
           write(0,*) ' The number of Arnoldi vectors generated',\
           ' (NCV) is ', ncv
           write(0,*) ' What portion of the spectrum: ', which
           write(0,*) ' The number of converged Ritz values is ', \
           nconv 
           write(0,*)  ' The number of Implicit Arnoldi update',\
           ' iterations taken is ', iparam(3)
           write(0,*) ' The number of OP*x is ', iparam(9)
           write(0,*) ' The convergence criterion is ', tol
           write(0,*) ' '


        end if !!!!!uncertain


        write(0,*) 'size of v/max/min/sum/ave',size(v),maxval(v),minval(v),sum(v),sum(v)/size(v)

9000    continue
        ! stop
!!$
!!$
     end do 


     write(0,*) 'nt,nx',nt,nx




     L=50.  !number of cuts
     allocate(cut(L-1,2))

     !  do eig_it=1,2
     it=1

     !outvec=v(1:nt*nx)   !!!!!new method
     !outvec=v(nt*nx+1:2*nt*nx)

     outvec=v(1:nt*nx,2)
     !outvec=v(1:100,2)
     !outvec=Z_par_d(:,it)

     !    write(0,*) 'outvec'
     !    write(0,*) outvec
     !write(0,*) 'v',v(1:,1)
     !write(0,*) 'v',v(1:,2)
     !write(0,*) 'v',v(1:,3)

     !    write(0,*) 'd_ar',d_ar

!!$     do it=1,size(v(1:,1))
!!$        !write(0,*) 'd_ar',d_ar(it,1:)
!!$        write(0,*) 'v',v(it,1:)
!!$     end do
!!$
     do it=1,size(d_ar(1:,1)) 
        write(0,*) 'd_ar',d_ar(it,1:)
        !write(0,*) 'v',v(it,1:)
     end do
!!$     write(0,*) ' _SDRV1 '
!!$   stop 
     !    deallocate(W_par_s,Z_par_s)
!!!!!!!$$$$$$$$$$$$$$$$  calculate  D_mat^-.5*main_eig 
     do ix=1,nx*nt
        outvec2(ix)=outvec(ix)*d_vec_exp(ix)
     end do

     !write(0,*) 'outvec2'
     !write(0,*) outvec2

!!!$$$$$$$$$$$$$$$$$$$$$$$$$$  calculate a  bunch of different cuts $$$$$$$$$$$$$$$
     !find 5% point 
     five_percent=nint(real(nt*nx)/real(60)) !

     !outvec2(1)=4
     !outvec2(2)=2
     !outvec2(3)=3
     !outvec2(4)=1
     !write(0,*) 'outvec2',outvec2
     outvec3=outvec2
     call quick_sort(outvec3,nx*nt)

     !write(0,*) 'outvec2 sort',outvec2
     !stop
     min_eig=minval(outvec2)
     max_eig=maxval(outvec2)
     min_eig=outvec3(five_percent)
     max_eig=outvec3(nt*nx-five_percent)

     !   min_eig=-.00001
     !   max_eig=.00001

     if (max_eig<0) then
        max_eig=0
     end if
     if (max_eig>1.) then  ! was .00005 or .004
        max_eig=1.
     end if

     if (min_eig>0) then
        min_eig=0
     end if
     if (min_eig<-1.) then
        min_eig=-1.
     end if
     write(0,*) 'min_eig',min_eig
     write(0,*) 'max_eig',max_eig
     !min_eig=-.01
     !max_eig=.01
     !min_eig=-.000001
     !max_eig=+.000001


     range_eig=max_eig-min_eig
     stepsize_eig=range_eig/L
     max_steps=(max_eig-min_eig-2*stepsize_eig)/stepsize_eig

     write(0,*) 'range_eig',range_eig
     write(0,*) 'stepsize', stepsize_eig
     do it=1,L-1
        write(0,*) 'it',it
        ! cut_val=min_eig+stepsize_eig:stepsize_eig:max_eig-stepsize_eig ;
        itval=it
        cut_val=min_eig+stepsize_eig*itval
        write(0,*) 'where cut',cut_val
        cut(it,1)=calc_cut_sparse(outvec2,cut_val,sparse_mat)

        write(0,*) 'cut value--------->',cut(it,1)
        write(0,*) 'done with iteration' 
        outcut(it)=cut(it,1)

        cut(it,2)=cut_val
        !        cut(it,3)=eig_it
     end do
     !end do


     ! take mininum cut from cut vector
     min_cut_loc=minloc(cut(1:max_steps,1))
     min_cut=cut(min_cut_loc(1),2)

     !min_cut=.00008
     write(0,*) 'cutval', calc_cut_sparse(outvec2,min_cut,sparse_mat)
     !    min_cut_vec=cut(min_cut_loc(1),3)
     write(0,*) 'min_cut_loc', min_cut_loc
     write(0,*) 'min_cut',min_cut 
     write(0,*) 'min_cut_val',cut(min_cut_loc(1),1) 
     ! split eigenvector along cut_val
     do ix=1,nx*nt
        if (outvec2(ix)>=min_cut) then 
           eig_vec_split(ix)=1  !%group A
        else
           eig_vec_split(ix)=0  !% group B
        end if
     end do

     !reshape eig_vec_split into 2D
     eig_vec_split_2d =reshape(eig_vec_split,(/nt,nx/))
     do ix=1,nx
        do it=2,nt-1
           if (eig_vec_split_2d(ix,it-1)/=eig_vec_split_2d(ix,it)) horiz(ix,1)=it
           if (eig_vec_split_2d(ix,it+1)/=eig_vec_split_2d(ix,it)) horiz(ix,2)=it
        end do
     end do
     write(0,*) 'eigenvalues'
     write(0,*) 'd_ar', d_ar(1:,1)
     write(0,*) 'made it to end'
     !    call srite("out",Eig_mat_s,4*nt*nt*nx*nx*ny)
     call srite("out",eig_vec_split,4*nt*nx)
!!$
     call to_history("n1",nx,"y_out.H"); call to_history("n2",nt,"y_out.H")
     !    call to_history("n1",10,"y_out.H"); call to_history("n2",10,"y_out.H")
     call to_history("n3",ny,"y_out.H")
     call to_history("d1",1,"y_out.H"); call to_history("d2",1,"y_out.H")
     call to_history("d3",1,"y_out.H")
     call to_history("o1",0.,"y_out.H"); call to_history("o2",0.,"y_out.H")
     call to_history("o3",0.,"y_out.H")
     call to_history("esize",4,"y_out.H")
     call sep_write(outvec2,"y_out.H")	

     call to_history("n1",nt,"model.H"); call to_history("n2",nx,"model.H")
     call to_history("n3",1.,"model.H")
     call to_history("d1",1.,"model.H"); call to_history("d2",1,"model.H")
     call to_history("d3",1.,"model.H")
     call to_history("o1",0.,"model.H"); call to_history("o2",0.,"model.H")
     call to_history("o3",0.,"model.H")
     call to_history("esize",4,"model.H")
     call sep_write(norm_d,"model.H")
!!$
     call to_history("n1",nt,"model_clip.H"); call to_history("n2",nx,"model_clip.H")
     call to_history("n3",1.,"model_clip.H")
     call to_history("d1",1.,"model_clip.H"); call to_history("d2",1,"model_clip.H")
     call to_history("d3",1.,"model_clip.H")
     call to_history("o1",0.,"model_clip.H"); call to_history("o2",0.,"model_clip.H")
     call to_history("o3",0.,"model_clip.H")
     call to_history("esize",4,"model_clip.H")
     call sep_write(norm_d_clip,"model_clip.H")
!!$

     call to_history("n1",nt,"qc.H"); call to_history("n2",nx,"qc.H")
     call to_history("n3",1.,"qc.H")
     call to_history("d1",1.,"qc.H"); call to_history("d2",1,"qc.H")
     call to_history("d3",1.,"qc.H")
     call to_history("o1",0.,"qc.H"); call to_history("o2",0.,"qc.H")
     call to_history("o3",0.,"qc.H")
     call to_history("esize",4,"qc.H")
     call sep_write(weight_qc,"qc.H")

     call to_history("n1",nx*nt,"first_eig"); call to_history("n2",1,"first_eig")
     call to_history("n3",1.,"first_eig")
     call to_history("d1",1.,"first_eig"); call to_history("d2",1,"first_eig")
     call to_history("d3",1.,"first_eig")
     call to_history("o1",0.,"first_eig"); call to_history("o2",0.,"first_eig")
     call to_history("o3",0.,"first_eig")
     call to_history("esize",4,"first_eig")
     call sep_write(v(1:nt*nx,1)+v(1:nt*nx,2),"first_eig")
!!$
!!$     call to_history("n1",nx,"d_vec_exp3"); call to_history("n2",nt,"d_vec_exp3")
!!$     call to_history("n3",1.,"d_vec_exp3")
!!$     call to_history("d1",1.,"d_vec_exp3"); call to_history("d2",1,"d_vec_exp3")
!!$     call to_history("d3",1.,"d_vec_exp3")
!!$     call to_history("o1",0.,"d_vec_exp3"); call to_history("o2",0.,"d_vec_exp3")
!!$     call to_history("o3",0.,"d_vec_exp3")
!!$     call to_history("esize",4,"d_vec_exp3")
!!$     call sep_write(v(1:nx*nt,3),"d_vec_exp3")
!!$
!!$     call to_history("n1",nx,"d_vec_exp4"); call to_history("n2",nt,"d_vec_exp4")
!!$     call to_history("n3",1.,"d_vec_exp4")
!!$     call to_history("d1",1.,"d_vec_exp4"); call to_history("d2",1,"d_vec_exp4")
!!$     call to_history("d3",1.,"d_vec_exp4")
!!$     call to_history("o1",0.,"d_vec_exp4"); call to_history("o2",0.,"d_vec_exp4")
!!$     call to_history("o3",0.,"d_vec_exp4")
!!$     call to_history("esize",4,"d_vec_exp4")
!!$     call sep_write(v(1:nx*nt,4),"d_vec_exp4")
!!$
!!$     call to_history("n1",total_sparse,"Eig_sparse"); call to_history("n2",3,"Eig_sparse")
!!$     call to_history("n3",1.,"Eig_sparse")
!!$     call to_history("d1",1.,"Eig_sparse"); call to_history("d2",1,"Eig_sparse")
!!$     call to_history("d3",1.,"Eig_sparse")
!!$     call to_history("o1",0.,"Eig_sparse"); call to_history("o2",0.,"Eig_sparse")
!!$     call to_history("o3",0.,"Eig_sparse")
!!$     call to_history("esize",4,"Eig_sparse")
!!$     call sep_write(Eig_sparse,"Eig_sparse")

     call to_history("n1",nx,"horiz.H"); call to_history("n2",2,"horiz.H") 
     call to_history("n3",1.,"horiz.H")
     call to_history("d1",1.,"horiz.H"); call to_history("d2",1,"horiz.H")
     call to_history("d3",1.,"horiz.H")
     call to_history("o1",0.,"horiz.H"); call to_history("o2",0.,"horiz.H")
     call to_history("o3",0.,"horiz.H")
     call to_history("esize",4,"horiz.H")
     call sep_write(horiz,"horiz.H")


!!$ call to_history("n1",50,"outcut.H"); call to_history("n2",1,"outcut.H") 
!!$    call to_history("n3",1.,"outcut.H")
!!$     call to_history("d1",1.,"outcut.H"); call to_history("d2",1,"outcut.H")
!!$     call to_history("d3",1.,"outcut.H")
!!$     call to_history("o1",0.,"outcut.H"); call to_history("o2",0.,"outcut.H")
!!$     call to_history("o3",0.,"outcut.H")
!!$     call to_history("esize",4,"outcut.H")
!!$     call sep_write(outcut,"outcut.H")

   end program Segment_split



!!$
!!$      subroutine av_test (nx, v, w)
!!$      integer           nx, j, lo, n2
!!$      Real       v(nx*nx), w(nx*nx), one, h2
!!$      parameter         ( one = 1.0E+0 ) 
!!$
!!$      call tv(nx,v(1),w(1))
!!$      call saxpy(nx, -one, v(nx+1), 1, w(1), 1)
!!$
!!$      do 10 j = 2, nx-1
!!$         lo = (j-1)*nx
!!$         call tv(nx, v(lo+1), w(lo+1))
!!$         call saxpy(nx, -one, v(lo-nx+1), 1, w(lo+1), 1)
!!$         call saxpy(nx, -one, v(lo+nx+1), 1, w(lo+1), 1)
!!$  10  continue 
!!$
!!$      lo = (nx-1)*nx
!!$      call tv(nx, v(lo+1), w(lo+1))
!!$      call saxpy(nx, -one, v(lo-nx+1), 1, w(lo+1), 1)
!!$
!!$!c     Scale the vector w by (1/h^2), where h is the mesh size
!!$
!!$      n2 = nx*nx
!!$      h2 = one / real((nx+1)*(nx+1))
!!$ write(0,*) 'h2',1/h2
!!$     call sscal(n2, one/h2, w, 1) 
!!$      return
!!$      end
!!$
!!$!c-------------------------------------------------------------------
!!$      subroutine tv (nx, x, y)
!!$
!!$        integer           nx, j 
!!$        real      x(nx), y(nx), dd, dl, du
!!$
!!$        Real            one
!!$        parameter        (one = 1.0E+0 )
!!$
!!$        !c     Compute the matrix vector multiplication y<---T*x
!!$        !c     where T is a nx by nx tridiagonal matrix with DD on the 
!!$        !c     diagonal, DL on the subdiagonal, and DU on the superdiagonal.
!!$
!!$
!!$        dd  = 4.0E+0
!!$        dl  = -one 
!!$        du  = -one
!!$
!!$        y(1) =  dd*x(1) + du*x(2)
!!$        do 10 j = 2,nx-1
!!$           y(j) = dl*x(j-1) + dd*x(j) + du*x(j+1) 
!!$10         continue 
!!$           y(nx) =  dl*x(nx-1) + dd*x(nx) 
!!$           return
!!$        end do
!!$
!!$
!!$
!!$
!!$
!!$
!!$
!!$
!!$        subroutine sparse_mat_mult2 (mat,nx,nt, v, w)
!!$          integer           nx,nt, j, lo, n2
!!$          Real           v(nx*nt), w(nx*nt), one, h2
!!$          real,dimension(:,:)	 ::mat
!!$          !     parameter         ( one = 1.0E+0 ) 
!!$
!!$          integer               ::irow,icol,nrow,ncol,inonzero,nnonzero
!!$          nnonzero=size(mat(1:,1))
!!$
!!$          do inonzero=1,nnonzero
!!$             irow=mat(inonzero,1)
!!$             icol=mat(inonzero,2)
!!$             w(irow)=w(irow)+mat(inonzero,3)*v(icol)
!!$          end do
!!$
!!$
!!$
!!$
!!$        end subroutine sparse_mat_mult2
!!$
!!$
!!$
!!$
