program Subsample_2D
  use sep
  use sorting_mod
  !
  !input a 3D data-set and subsample it
  implicit none
  real,dimension(:,:)   :: in_data,out_data,sq
  real,dimension(:)   ::sq_1D
  real                  ::avr_val
  integer               ::it,ix,iy,n1,n2,n1_new,n2_new,subsam,esize,perc,perc_index
  ! call initpar()

  call sep_init ()
  call initpar()
  call from_history (n1,n2)
  call from_param("subsam",subsam,5)
  call from_param("perc",perc,20)  ! bottom ten percent
  !  call from_history (n1,n2)
  allocate(in_data(n1,n2))
  call sep_read (in_data) 
  write(0,*) 'subsam',subsam
  n1_new=n1/subsam
  n2_new=n2/subsam
  allocate(out_data(n1_new,n2_new),sq(subsam,subsam),sq_1D(subsam*subsam))

  perc_index= real(subsam)*(real(perc))/100.

  do it=1,n1_new
     do ix=1,n2_new
        sq=in_data(1+(it-1)*subsam:subsam+(it-1)*subsam,1+(ix-1)*subsam:subsam+(ix-1)*subsam) !grap a square
        sq_1D=reshape(sq,(/size(sq)/)) ! reshape into 1D
        call quick_sort(sq_1D,subsam*subsam) !sort them
        avr_val=sum(sq_1D(1:perc_index))/size(sq_1D(perc_index:))
        out_data(it,ix)=avr_val
     end do
  end do


  write(0,*) n1,n2,real(n1/subsam)


!!$n1_new=int(real(n1)/real(subsam))
!!$
!!$
  call to_history( "n1", n1_new);  call to_history( "n2", n2_new);  call to_history( "n3", 1)
  call to_history( "d1", 1);  call to_history( "d2", 1);  call to_history( "d3", 1)
  call to_history( "o1", 0.);  call to_history( "o2", 0.);  call to_history( "o3", 0.)
  call to_history("esize",4);
!!$
!!$
  call srite("out",out_data,4*n1_new*n2_new)
call sep_close()
end program Subsample_2D
